﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;

public class bigtowerscript : MonoBehaviour {
	public Renderer rend;
	rtcmixmain RTcmix;
	int objno = 4; // change this for multiple RTcmix instantiations
	int stopit;
	float targettime;
	float startpt = 0.0f;
	float incr = 0.005f;

	// Use this for initialization
	void Start () {
		// up & down
		stopit = 0;
		targettime = 10.0f;

		// color
		rend = GetComponent<Renderer>();

		// RTcmix
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno);
	}


	// Update is called once per frame
	void Update () {
		if (Time.time > targettime)
			stopit = 1;

		if (stopit == 1) {
			// up & down
			float heightY = (startpt * 4.0f) - 2.0f;
			if (heightY >= 2.0f)
				incr = -incr;
			startpt = startpt + incr;
		 
			Vector3 updown = new Vector3 (transform.position.x, heightY, transform.position.z);
			transform.position = updown;

			float scaleX = Mathf.Cos(Time.time) * 0.5F + 1;
			float scaleY = Mathf.Sin(Time.time) * 0.5F + 1;
			rend.material.mainTextureScale = new Vector2(scaleX, scaleY);

			// distance/amp
			GameObject observer = GameObject.Find ("observer");
			Transform observertransform = observer.transform;
			float distance = Vector3.Distance (observertransform.position, transform.position);

			// distance is between 20.0 and 1.0 (arbitrary)
			float ampmult = 1.0f - (distance/20.0f);
			if (ampmult < 0.1f) ampmult = 0.1f;

			// RTcmix
			RTcmix.setpfieldRTcmix (1, 121.0f + (scaleX * 20.0f), objno);
			RTcmix.setpfieldRTcmix (2, heightY + 2.0f, objno);
			RTcmix.setpfieldRTcmix (3, ampmult, objno);

			if (heightY < -2.0f) {
				stopit = 0;
				targettime = Time.time + 5.0f;
				startpt = 0.0f;
				incr = 0.005f;
			}
		}


	}


	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
// FMINST(outsk, dur, AMP, CARFREQ (Hz/oct.pc), MODFREQ (Hz/oct.pc), LOWINDEX, HIGHINDEX[, PAN, WAVETABLE, INDEXENV])
// GVERB(outsk, insk, dur, AMP, ROOMSIZE, RVBTIME, DAMPING, BANDWIDTH, DRYLEVEL, EARLYREFLECT, RVBTAIL, RINGDOWN[, INCHAN]
			String score = "bus_config(\"FMINST\", \"aux 0-1 out\")  " +
				"bus_config(\"GVERB\", \"aux 0-1 in\", \"out 0-1\")  " +
				"GVERB(0, 0, 9999, 0.9, 178.0, 7.0, 0.5, 0.34, -10.0, -11.0, -9.0, 7.0)  " +
				"wave = maketable(\"wave\", 1000, \"sine\")  " +
				"modfreqb = makeconnection(\"inlet\", 1, 121)  " +
				"indexb = makeconnection(\"inlet\", 2, 0)  " +
				"ampmultb = makeconnection(\"inlet\", 3, 0)  " +
				"FMINST(0, 9999, 10000*indexb*ampmultb, 100, modfreqb, 0, 10, 0.5, wave, indexb)";
			RTcmix.SendScore(score, objno);
		}
	}


	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
