﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;

public class tower2script : MonoBehaviour {
	private float speed;
	public Renderer rend;
	int objno = 1; // change this for multiple RTcmix instantiations
	rtcmixmain RTcmix;

	// Use this for initialization
	void Start () {
		// up & down
		speed = 1.7f;

		// color
		rend = GetComponent<Renderer>();

		// RTcmix
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno);
	}


	// Update is called once per frame
	void Update () {
		// up & down
		float heightY = Mathf.Cos(Time.time * speed);
		Vector3 updown = new Vector3(transform.position.x, heightY, transform.position.z);
		transform.position = updown;

		// color
		float green = Mathf.PingPong(Time.time * 1.0f, 1.0f);
		rend.material.color = new Color (0.7f, green, 0.1f);

		// distance/amp
		GameObject observer = GameObject.Find ("observer");
		Transform observertransform = observer.transform;

		float distance = Vector3.Distance (observertransform.position, transform.position);

		// distance is between 20.0 and 1.0 (arbitrary)
		float ampmult = 1.0f - (distance/20.0f);
		if (ampmult < 0.1f) ampmult = 0.1f;

		// RTcmix
		RTcmix.setpfieldRTcmix (1, 270.0f + (green*20.0f), objno);
		RTcmix.setpfieldRTcmix (2, heightY/2.0f+1.0f, objno);
		RTcmix.setpfieldRTcmix (3, ampmult, objno);
	}


	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
// FMINST(outsk, dur, AMP, CARFREQ (Hz/oct.pc), MODFREQ (Hz/oct.pc), LOWINDEX, HIGHINDEX[, PAN, WAVETABLE, INDEXENV])
// GVERB(outsk, insk, dur, AMP, ROOMSIZE, RVBTIME, DAMPING, BANDWIDTH, DRYLEVEL, EARLYREFLECT, RVBTAIL, RINGDOWN[, INCHAN]
			String score = "bus_config(\"FMINST\", \"aux 0-1 out\")  " +
				"bus_config(\"GVERB\", \"aux 0-1 in\", \"out 0-1\")  " +
				"GVERB(0, 0, 9999, 0.9, 178.0, 4.0, 0.5, 0.34, -1.0, -11.0, -9.0, 7.0)  " +
				"wave = maketable(\"wave\", 1000, \"sine\")  " +
				"modfreq2 = makeconnection(\"inlet\", 1, 270)  " +
				"index2 = makeconnection(\"inlet\", 2, 0)  " +
				"ampmult2 = makeconnection(\"inlet\", 3, 0)  " +
				"FMINST(0, 9999, 5000*index2*ampmult2, 270, modfreq2, 0, 10, 0.5, wave, index2)";
			RTcmix.SendScore (score, objno);
		}
	}

		
	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
